unit upersonlisting;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  DBCtrls, LR_Class, fpreport, fpreportdb, fpreportpdfexport, EasyLazFreeType, LazFreeTypeFontCollection,
  fpjsonreport, fpreportformexport, ZDataset, ureportform, DB;

type

  { TfrmPersonListing }

  TfrmPersonListing = class(TfrmReportForm)
    cmbRelation: TDBLookupComboBox;
    cmbOccupation: TDBLookupComboBox;
    cmbType: TDBLookupComboBox;
    dsRelation: TDataSource;
    dsPersonType: TDataSource;
    dsOccupation: TDataSource;
    eCityFrom: TEdit;
    eCityTo: TEdit;
    eNameFrom: TEdit;
    eNameTo: TEdit;
    ePIDFrom: TEdit;
    ePIDTo: TEdit;
    fprPersonListing: TFPJSONReport;
    fprPreview: TFPreportPreviewExport;
    fprdsPerson: TFPReportDatasetData;
    fprPDF: TFPReportExportPDF;
    lbCity: TLabel;
    lbFirstName: TLabel;
    lbFrom: TLabel;
    lbOccupation: TLabel;
    lbPID: TLabel;
    lbRelation: TLabel;
    lbTo: TLabel;
    lbType: TLabel;
    mAddressTitle: TFPReportMemo;
    Memo1: TMemo;
    mMobileTitle: TFPReportMemo;
    mNameTitle: TFPReportMemo;
    mPhoneTitle: TFPReportMemo;
    qrPersonListingADDRESS1: TStringField;
    qrPersonListingADDRESS2: TStringField;
    qrPersonListingANNIVERSARY: TDateField;
    qrPersonListingBIRTHDATE: TDateField;
    qrPersonListingCITY: TStringField;
    qrPersonListingCOUNTRY: TStringField;
    qrPersonListingEMAIL: TStringField;
    qrPersonListingFIRSTNAME: TStringField;
    qrPersonListingLASTNAME: TStringField;
    qrPersonListingMIDDLENAME: TStringField;
    qrPersonListingMOBILE: TStringField;
    qrPersonListingOCCUPATION: TStringField;
    qrPersonListingPHONE: TStringField;
    qrPersonListingPID: TLongintField;
    qrPersonListingRELATION: TStringField;
    qrPersonListingSTATE: TStringField;
    qrPersonListingTYPEDESCRIPTION: TStringField;
    qrPersonListingZIP: TStringField;
    rgSort: TRadioGroup;
    qrPersonListing: TZReadOnlyQuery;
    procedure btPreviewClick(Sender: TObject);
    function FilterData: boolean;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);

  private

  public

  end;

var
  frmPersonListing: TfrmPersonListing;
  sFilter : string;

implementation

{$R *.frm}

{ TfrmPersonListing }

function TfrmPersonListing.FilterData: boolean;
begin
  sFilter := '(';
  Memo1.Text := sFilter;
  sFilter := sFilter + ePIDFrom.Text + ',';
  sFilter := sFilter + ePIDTo.Text + ',';
  sFilter := sFilter + QuotedStr(eNameFrom.Text) + ',';
  sFilter := sFilter + QuotedStr(eNameTo.Text) + ',';
  sFilter := sFilter + QuotedStr(eCityFrom.Text) + ',';
  sFilter := sFilter + QuotedStr(eCityTo.Text) + ',';
  if cmbRelation.KeyValue = null then
    sFilter := sFilter + '0,'
  else
    sFilter := sFilter + IntToStr(cmbRelation.KeyValue) + ',';
  if cmbType.KeyValue = null then
    sFilter := sFilter + '0,'
  else
    sFilter := sFilter + IntToStr(cmbType.KeyValue) + ',';
  if cmbOccupation.KeyValue = null then
    sFilter := sFilter + '0,'
  else
    sFilter := sFilter + IntToStr(cmbOccupation.KeyValue) + ',';
  sFilter := sFilter + IntToStr(rgSort.ItemIndex + 1);
  sFilter := sFilter + ')';
  Memo1.Text := sFilter;
  if qrPersonListing.Active then
    qrPersonListing.Close;
  qrPersonListing.SQL.Clear;
  qrPersonListing.SQL.Text := 'SELECT * FROM  sp_personreport ' + sFilter;
  qrPersonListing.Open;
  result := qrPersonListing.Active;
end;

procedure TfrmPersonListing.btPreviewClick(Sender: TObject);
begin
  if Filterdata then
  begin
    fprPersonListing.LoadFromFile(ExtractFilePath(ParamStr(0)) + '\Reports\PersonListing.json');
    fprPersonListing.RunReport;
    Memo1.Text := 'Here';
    fprPersonListing.RenderReport(fprPreview);


  end;
end;

procedure TfrmPersonListing.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  dsRelation.DataSet.Close;
  dsPersonType.DataSet.Close;
  dsOccupation.DataSet.Close;
  if qrPersonListing.Active then
    qrPersonListing.Close;
end;

procedure TfrmPersonListing.FormShow(Sender: TObject);
begin
  dsRelation.DataSet.Open;
  dsPersonType.DataSet.Open;
  dsOccupation.DataSet.Open;
end;

end.

